#!/bin/sh
#
#cropcalc.sh (Version 0.3.1) erzeugt avs-Dateien, wie sie Avisynth zum Frameserven bentigt
#
#Syntax:
#
#cropcalc.sh x-wert-links y-wert-oben x-wert-rechts y-wert-unten gewnschte-hhe deinterlace "d2v-datei-name"
#
#Erluterung:
#
#x-wert-links, y-wert-oben, x-wert-rechts und y-wert-unten sind die Werte um die gecroppt werden
#soll. Sie lassen sich ermitteln, indem man man sie (und gewnschte Hhe) zuerst auf 0 stellt,
#den Film dann mit VirtualDub ffnet, irgendeinen Filter benutzt, und dann croppt. Die Werte in
#den "Eingabelchern"sind die gesuchten Werte. Nun kann man cropcalc.sh mit den entgltigen
#Werten nochmal aufrufen.
#
#gewnschte-hhe ist die Hhe, auf die LanczosResize croppen soll.
#Als Breite wird immer 640 genommen, passende Hhen sind 480(4:3 Vollbild), 360(Widescreen) und
#272 (Cinemascope). Durch setzen auf 0 wird die Ursprungsgre beibehalten).
#
#deinterlace gibt an, ob dinterlaced werden soll (1) oder nicht (0).
#
#d2v-datei-name ist der Name der d2v-Datei. Anfhrungszeichen werden bentigt, wenn der Name
#Leerzeichen enthllt. Leerzeichen mssen nicht escaped werden, da jedes Argument ab $7
#als Teil des Namens interpretiert wird.
#
#
#Zum awk-Progamm:
#
#Die Variable mpeg2dec_dlldirectory muss angepasst werden. Sie enthllt den Pfad der mpeg2dec.dll
#in der Form "Partitionsbuchstabe:\\Ebene1\\Ebene2\\usw". Backslashes("\") sind zu escapen("\\").
#
#Falls man dieses Skript umschreibt, und noch andere Variabeln an awk bergibt,
#sollte man sie vor dem d2v-Dateinamen einbauen, und den Wert i entsprechend inkrementieren.
#
#xoriginal und yoriginal sind die Werte des Quellformats, bei PAL-DVDs knnen die Werte im
#awk-Programm unverndert bleiben, bei NTSC-DVDs oder (S)VCDs mssen sie natrlich angepasst
#werden.
#
#Dieses Skript steht unter der GPL.
#
#Fragen, Anregungen, gefundene Fehler oder Verbesserungen werden gerne per Mail entgegen genommen.
#
#Fabian Keil (fk@fabiankeil.de)
#Updates eventuell unter http://www.fabiankeil.de/sourcecode.html
version=0.3.1
printf "cropcalc ($version)\nFabian Keil (fk@fabiankeil.de)\nhttp://www.fabiankeil.de/sourcecode.html\n\n"

echo "In \"$7.avs\" wird folgendes geschrieben:"
echo $1 $2 $3 $4 $5 $6 $7|
awk '
END{
 xoriginal = 720;
 yoriginal = 576;
 greedyhma_dlldirectory = "D:\\Programme\\Gordian Knot 0.28";
 topfirst=1;
 mpeg2dec_dlldirectory="D:\\Programme\\DVD2AVI";
 xneu = xoriginal - $1 -$3;
 yneu = yoriginal - $2 -$4;
 printf "LoadPlugin(\"%s\\mpeg2dec.dll\") \n",mpeg2dec_dlldirectory;
 if ($6==1){  
  printf "LoadPlugin(\"%s\\GreedyHMA.dll\") \n",greedyhma_dlldirectory;
 }
 printf "mpeg2source(\"";
 i=7;
 while($(i+1)) printf "%s ",$(i++);
 printf "%s\") \n",$i;
 if ($6==1){
  printf "GreedyHMA(%i,0,1,0,0,0,0,0)\n",topfirst;
 }
 printf "Crop(%i,%i,%i,%i) \n",$1,$2,xneu,yneu;
 if ($5!=0){
  printf "LanczosResize(%i,%i)\n",640,$5;
 }
}'| unix2dos |tee "$7".avs 
